local assets=
{
    Asset("ANIM", "anim/dropped.zip"),
    Asset("ATLAS", "images/inventoryimages/dug_cave_banana_tree.xml"),
    Asset("IMAGE", "images/inventoryimages/dug_cave_banana_tree.tex"),

}

local function test_ground(inst, pt)
	local tiletype = GetGroundTypeAtPosition(pt)
	local ground_OK = tiletype == GROUND.MUD
	
	if ground_OK then
	    local ents = TheSim:FindEntities(pt.x,pt.y,pt.z, 4)
		local min_spacing = inst.components.deployable.min_spacing or 2

	    for k, v in pairs(ents) do
			if v ~= inst and v.entity:IsValid() and v.entity:IsVisible() and not v:HasTag("player") and not v.components.placer and v.parent == nil and not v:HasTag("FX") then
				if distsq( Vector3(v.Transform:GetWorldPosition()), pt) < min_spacing*min_spacing then
					return false
				end
			end
		end
		
		return true

	end
	return false
	
end

local function CanDeploy(inst) return true end

local function ondeploy(inst, pt)
	local tree = SpawnPrefab("cave_banana_tree") 
	if tree then 
		tree.Transform:SetPosition(pt.x, pt.y, pt.z) 
		inst.components.stackable:Get():Remove()
		tree.components.pickable:OnTransplant()
		tree.SoundEmitter:PlaySound("dontstarve/wilson/plant_tree")
	end 
end

	local function fn(Sim)
		local inst = CreateEntity()
		inst.entity:AddTransform()
		inst.entity:AddAnimState()
		MakeInventoryPhysics(inst)
	    
		inst.AnimState:SetBank("dug")
		inst.AnimState:SetBuild("dropped")
		inst.AnimState:PlayAnimation("dropped_banana")

		inst:AddComponent("pickable")
		inst:AddComponent("stackable")
		inst.components.stackable.maxsize = TUNING.STACK_SIZE_LARGEITEM
		
		inst:AddComponent("inspectable")
		inst.components.inspectable.nameoverride = "dug_cave_banana_tree"
		inst:AddComponent("inventoryitem")
			inst.components.inventoryitem.atlasname = "images/inventoryimages/dug_cave_banana_tree.xml"
	    inst.components.inventoryitem.imagename = "dug_cave_banana_tree"
		
		inst:AddComponent("fuel")
		inst.components.fuel.fuelvalue = TUNING.LARGE_FUEL
	    

        	MakeMediumBurnable(inst)
			MakeSmallPropagator(inst)
		
	    inst:AddComponent("deployable")
	    inst.components.deployable.ondeploy = ondeploy
	    inst.components.deployable.test = test_ground
	    inst.components.deployable.min_spacing = 2
	    
		
	    
		---------------------  
		return inst      
	end

	return Prefab( "common/objects/dug_cave_banana_tree", fn, assets),
		MakePlacer( "common/dug_cave_banana_tree_placer", "cave_banana_tree", "cave_banana_tree", "idle_loop")