
local function createflower(data)

    local assets = 
    {
	Asset("ANIM", "anim/dropped.zip"),
        Asset("ATLAS", "images/inventoryimages/dug_flower_cave"..data.animname..".xml"),
        Asset("IMAGE", "images/inventoryimages/dug_flower_cave"..data.animname..".tex"),
    }

   local function test_ground(inst, pt)
	local tiletype = GetGroundTypeAtPosition(pt)
	local ground_OK = tiletype == GROUND.MUD or tiletype == GROUND.MARSH or tiletype == GROUND.TIDALMARSH
	
	if ground_OK then
	    local ents = TheSim:FindEntities(pt.x,pt.y,pt.z, 4)
		local min_spacing = inst.components.deployable.min_spacing or 2

	    for k, v in pairs(ents) do
			if v ~= inst and v.entity:IsValid() and v.entity:IsVisible() and not v:HasTag("player") and not v.components.placer and v.parent == nil and not v:HasTag("FX") then
				if distsq( Vector3(v.Transform:GetWorldPosition()), pt) < min_spacing*min_spacing then
					return false
				end
			end
		end
		
		return true

	end
	return false
	
end

    local function ondeploy(inst, pt)
	local tree = SpawnPrefab(data.name) 
	if tree then 
		tree.Transform:SetPosition(pt.x, pt.y, pt.z) 
		inst.components.stackable:Get():Remove()
		tree.components.pickable:OnTransplant()
        tree.SoundEmitter:PlaySound("dontstarve/wilson/plant_tree")
	end 
end


    local function fn(Sim)
        local inst = CreateEntity()
        inst.entity:AddTransform()
        inst.entity:AddAnimState()

        MakeInventoryPhysics(inst)
        
        inst.AnimState:SetBank("dug")
        inst.AnimState:SetBuild("dropped")
        inst.AnimState:PlayAnimation("dropped_flower_cave"..data.animname)

        inst:AddComponent("deployable")
        inst.components.deployable.test = test_ground
        inst.components.deployable.ondeploy = ondeploy
        
        inst:AddComponent("stackable")
        inst.components.stackable.maxsize = TUNING.STACK_SIZE_LARGEITEM

        inst:AddComponent("inspectable")
        
        MakeMediumBurnable(inst, TUNING.MEDIUM_BURNTIME)
        MakeSmallPropagator(inst)

        inst:AddComponent("inventoryitem")
        inst.components.inventoryitem.atlasname = "images/inventoryimages/dug_"..data.name..".xml"
        
        return inst
    end

    return Prefab( "common/inventory/dug_flower_cave"..data.animname, fn, assets)
end

local data = { {name = "flower_cave", animname="", placer = "_single"}, 
               {name = "flower_cave_double", animname="_double", placer = "_double"},
               {name = "flower_cave_triple", animname="_triple", placer = "_triple"}
           }
local prefabs = {}

for k,v in pairs(data) do
    local flower = createflower(v)
    table.insert(prefabs, flower)
    table.insert(prefabs, MakePlacer( "common/dug_flower_cave"..v.animname.."_placer", "bulb_plant"..v.placer, "bulb_plant"..v.placer, "picked" ))
end

return unpack(prefabs) 
