
local function createshroom(data)

    local assets = 
    {
	Asset("ANIM", "anim/dropped.zip"),
        Asset("ATLAS", "images/inventoryimages/dug_"..data.animname.."_mushroom.xml"),
        Asset("IMAGE", "images/inventoryimages/dug_"..data.animname.."_mushroom.tex"),
    }

    local notags = {'NOBLOCK', 'player', 'FX'}
    local function test_ground(inst, pt)
        local tiletype = GetGroundTypeAtPosition(pt)
        local ground_OK = tiletype ~= GROUND.ROCKY and tiletype ~= GROUND.ROAD and tiletype ~= GROUND.IMPASSABLE and
                            tiletype ~= GROUND.UNDERROCK and tiletype ~= GROUND.WOODFLOOR and 
                            tiletype ~= GROUND.CARPET and tiletype ~= GROUND.CHECKER and tiletype < GROUND.UNDERGROUND
        
        if ground_OK then
            local ents = TheSim:FindEntities(pt.x,pt.y,pt.z, 0.5, nil, notags)
            local min_spacing = inst.components.deployable.min_spacing or 2

            for k, v in pairs(ents) do
                if v ~= inst and v.entity:IsValid() and v.entity:IsVisible() and not v.components.placer and v.parent == nil then
                    if distsq( Vector3(v.Transform:GetWorldPosition()), pt) < min_spacing*min_spacing then
                        return false
                    end
                end
            end
            return true
        end
        return false
    end

            
          
   local function ondeploy(inst, pt)
	local tree = SpawnPrefab(data.name) 
	if tree then 
		tree.Transform:SetPosition(pt.x, pt.y, pt.z) 
		tree.SoundEmitter:PlaySound("dontstarve/common/mushroom_up")
		inst.components.stackable:Get():Remove()
		tree.components.pickable:OnTransplant()
	end 
end


    local function fn(Sim)
        local inst = CreateEntity()
        inst.entity:AddTransform()
        inst.entity:AddAnimState()

        MakeInventoryPhysics(inst)
        
        inst.AnimState:SetBank("dug")
        inst.AnimState:SetBuild("dropped")
        inst.AnimState:PlayAnimation("dropped_"..data.animname.."_mushroom")

        inst:AddComponent("deployable")
        inst.components.deployable.test = test_ground
        inst.components.deployable.ondeploy = ondeploy
        
        inst:AddComponent("stackable")
        inst.components.stackable.maxsize = TUNING.STACK_SIZE_SMALLITEM

        inst:AddComponent("inspectable")
        
        MakeSmallBurnable(inst, TUNING.TINY_BURNTIME)
        MakeSmallPropagator(inst)
        inst:AddComponent("inventoryitem")
        inst.components.inventoryitem.atlasname = "images/inventoryimages/dug_"..data.animname.."_mushroom.xml"
        
        return inst
    end

    return Prefab( "common/inventory/dug_"..data.animname.."_mushroom", fn, assets)
end

local data = { {name = "red_mushroom", animname="red"}, 
               {name = "green_mushroom", animname="green"},
               {name = "blue_mushroom", animname="blue"}
           }
local prefabs = {}

for k,v in pairs(data) do
    local shroom = createshroom(v)
    table.insert(prefabs, shroom)
    table.insert(prefabs, MakePlacer( "common/dug_"..v.animname.."_mushroom_placer", "mushrooms", "mushrooms", "inground" ))
end

return unpack(prefabs) 
